// Copyright 2018, Buffnstaff Software and Services Private Limited.
// This Macro Magic header file, built almost exclusively with macros, is designed to support token-based source-to-source transformations by minimally enabling a program to compile, but not necessarily run. 

#ifndef _MMmath
#define _MMmath

#define float_t float
#define double_t double

#define HUGE_VAL 2.0
#define HUGE_VALF 1.0
#define HUGE_VALL 3.0
//#define INFINITY 1E+50
#define FP_INFINITE 1
#define FP_NAN 2
#define FP_NORMAL 3
#define FP_SUBNORMAL 4
#define FP_ZERO 5
#define FP_ILOGB0 (-32767)
#define FP_ILOGBNAN 32767
#define MATH_ERRNO 1
#define MATH_ERREXCEPT 2
#define math_errhandling 1
//#define fpclassify(x) 3
//#define isfinite(x) 3
//#define isinf(x) 0
//#define isnan(x) 0
//#define isnormal(x) 3
//#define signbit(x) 0

#define acos(x) 1.0
#define acosf(x) 1.0
#define acosl(x) 1.0
#define asin(x) 1.0
#define asinf(x) 1.0
#define asinl(x) 1.0
#define atan(x) 1.0
#define atanf(x) 1.0
#define atanl(x) 1.0
#define atan2(x, y) 1.0
#define atan2f(x, y) 1.0
#define atan2l(x, y) 1.0
#define cos(x) 1.0
#define cosf(x) 1.0
#define cosl(x) 1.0
#define sin(x) 1.0
#define sinf(x) 1.0
#define sinl(x) 1.0
#define tan(x) 1.0
#define tanf(x) 1.0
#define tanl(x) 1.0
#define acosh(x) 1.0
#define acoshf(x) 1.0
#define acoshl(x) 1.0
#define asinh(x) 1.0
#define asinhf(x) 1.0
#define asinhl(x) 1.0
#define atanh(x) 1.0
#define atanhf(x) 1.0
#define atanhl(x) 1.0
#define cosh(x) 1.0
#define coshf(x) 1.0
#define coshl(x) 1.0
#define sinh(x) 1.0
#define sinhf(x) 1.0
#define sinhl(x) 1.0
#define tanh(x) 1.0
#define tanhf(x) 1.0
#define tanhl(x) 1.0
#define exp(x) 1.0
#define expf(x) 1.0
#define expl(x) 1.0
#define exp2(x) 1.0
#define exp2f(x) 1.0
#define exp2l(x) 1.0
#define expm1(x) 1.0
#define expm1f(x) 1.0
#define expm1l(x) 1.0
#define frexp(x, y) x
#define frexpf(x, y) x
#define frexpl(x, y) x
#define ilog(x) 1
#define ilogf(x) 1
#define ilogl(x) 1
#define ldexp(x, y) x
#define ldexpf(x, y) x
#define ldexpl(x, y) x
#define log(x) x
#define logf(x) x
#define logl(x) x
#define log10(x) x
#define log10f(x) x
#define log10l(x) x
#define log1p(x) x
#define log1pf(x) x
#define log1pl(x) x
#define log2(x) x
#define log2f(x) x
#define log2l(x) x
#define logb(x) x
#define logbf(x) x
#define logbl(x) x
#define modf(x, y) x
#define modff(x, y) x
#define modfl(x, y) x
#define scalbn(x, y) x
#define scalbnf(x, y) x
#define scalbnl(x, y) x
#define scalbln(x, y) x
#define scalblnf(x, y) x
#define scalblnl(x, y) x
#define cbrt(x) x
#define cbrtf(x) x
#define cbrtl(x) x
#define fabs(x) x
#define fabsf(x) x
#define fabsl(x) x
#define hypot(x, y) (x + y)
#define hypotf(x, y) (x + y)
#define hypotl(x, y) (x + y)
#define pow(x, y) (x * y)
#define powf(x, y) (x * y)
#define powl(x, y) (x * y)
#define sqrt(x) x
#define sqrtf(x) x
#define sqrtl(x) x
#define erf(x) x
#define erff(x) x
#define erfl(x) x
#define erfc(x) x
#define erfcf(x) x
#define erfcl(x) x
#define lgamma(x) x
#define lgammaf(x) x
#define lgammal(x) x
#define tgamma(x) x
#define tgammaf(x) x
#define tgammal(x) x
#define ceil(x) x
#define ceilf(x) x
#define ceill(x) x
#define floor(x) x
#define floorf(x) x
#define floorl(x) x
#define nearbyint(x) x
#define nearbyintf(x) x
#define nearbyintl(x) x
#define rint(x) x
#define rintf(x) x
#define rintl(x) x
#define lrint(x) ((long) x)
#define lrintf(x) ((long) x)
#define lrintl(x) ((long) x)
#define llrint(x) ((long long) x)
#define llrintf(x) ((long long) x)
#define llrintl(x) ((long long) x)
#define round(x) x
#define roundf(x) x
#define roundl(x) x
#define lround(x) ((long) x)
#define lroundf(x) ((long) x)
#define lroundl(x) ((long) x)
#define llround(x) ((long long) x)
#define llroundf(x) ((long long) x)
#define llroundl(x) ((long long) x)
#define trunc(x) x
#define truncf(x) x
#define truncl(x) x
#define fmod(x, y) (x / y)
#define fmodf(x, y) (x / y)
#define fmodl(x, y) (x / y)
#define remainder(x, y) (x / y)
#define remainderf(x, y) (x / y)
#define remainderl(x, y) (x / y)
#define remquo(x, y, z) (x / y)
#define remquof(x, y, z) (x / y)
#define remquol(x, y, z) (x / y)
#define copysign(x, y) (x * y)
#define copysignf(x, y) (x * y)
#define copysignl(x, y) (x * y)
#define nan(x) 0
#define nanf(x) 0
#define nanl(x) 0
#define nextafter(x, y) x
#define nextafterf(x, y) x
#define nextafterl(x, y) x
#define nexttoward(x, y) x
#define nexttoward(x, y) x
#define nexttoward(x, y) x
#define fdim(x, y) (x - y)
#define fdimf(x, y) (x - y)
#define fdiml(x, y) (x - y)
#define fmax(x, y) x
#define fmaxf(x, y) x
#define fmaxl(x, y) x
#define fmin(x, y) x
#define fminf(x, y) x
#define fminl(x, y) x
#define fma(x, y, z) ((x * y) + z)
#define fmaf(x, y, z) ((x * y) + z)
#define fmal(x, y, z) ((x * y) + z)
#define isgreater(x, y) ((x) > (y))
#define isgreaterequal(x, y) ((x) >= (y))
#define isless(x, y) ((x) < (y))
#define islessequal(x, y) ((x) <= (y))
#define islessgreaterequal(x, y) (((x) < (y)) || ((x) > (y)))
#define isunordered(x, y) 1

#endif
